<!----------------------------------------------------------------------------------------------------------------------
  -- simpleAuth
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <BFormGroup
        id="auth-group"
        description="Optional authentication string (typically a token)."
        label="Authentication"
        label-for="auth-input"
    >
        <BInputGroup class="input-group" size="sm">
            <BFormInput
                id="auth-input"
                v-model="auth"
                class="h-100"
                placeholder="ex: &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9...&quot;"
                autocomplete="off"
                :disabled="props.disabled"
            />
            <template #append>
                <BButton class="input-button" @click="clearAuthentication()">
                    <Fa icon="times" />
                </BButton>
            </template>
        </BInputGroup>
    </BFormGroup>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<script setup lang="ts">
    //------------------------------------------------------------------------------------------------------------------
    // Component Definition
    //------------------------------------------------------------------------------------------------------------------

    interface Props
    {
        disabled ?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        disabled: false,
    });

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const auth = defineModel<string | undefined>('auth', { required: true });

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function clearAuthentication() : void
    {
        auth.value = undefined;
    }
</script>

<!--------------------------------------------------------------------------------------------------------------------->
